#include <QApplication>
#include <QDebug>
#include <QFile>
#include <QWidget>
//#include <QtUiTools/QUiLoader>
#include <QMenuBar>
#include <QMainWindow>
#include <QTextStream>
#include <QScrollArea>

#include "MenuVisu.h"
#include "MenuM.h"
#include "MainWindow.h"
#include "DataBase.h"
QString directory = "MenuExplorer/";


int main(int argc, char *argv[]){
    //path
    QString path(argv[0]);
    int index = path.indexOf("/MenuVisu/");
    path = path.mid(0, index + 10);
    path+=directory;

    QApplication a(argc, argv);
    MainWindow *mainWindow = new MainWindow(0);
    mainWindow->show();

    DataBase dataBase;
    dataBase.loadData(path+"/database/database_menus.xml");
    //mainWindow->loadMenuBars(dataBase.getMenuBars());
    mainWindow->setDataBase(&dataBase);
    mainWindow->loadDomMenuBars();

    return a.exec();
}

//int main2(int argc, char *argv[])
//{
//    QApplication a(argc, argv);
//    //MainWindow w;

//    if(argc!=2){
//        qDebug()<<"indicate the the file that you want to load";
//        return 0;
//    }

//    QString path(argv[0]);
//    QString name(argv[1]);
//    if(name.endsWith(".ui")){
//        name = name.left(name.length()-3);
//    }
//    QString menuFileName = name + ".ui";
//    QString freqFileName = name + ".freq";
//    QString imgFileName = name + ".png";

//    qDebug()<<"Menu: "<<menuFileName << " freq: "<<freqFileName;
//    int index = path.indexOf("/MenuVisu/");
//    path = path.mid(0, index + 10);
//    qDebug()<<argv[0]<< "  "<<index<< " "<< path;

//    //load frequency file
//    QFile freqFile(path+ directory+ "menus/" + freqFileName);
//    if (!freqFile.open(QIODevice::ReadOnly | QIODevice::Text)){
//            qDebug()<<"frequency file name is not valid";
//            return 0;
//    }

//    QTextStream stream(&freqFile);
//    QMap<QString, float> frequencyMap;
//    QString text = stream.readLine();//header;
//    while(!stream.atEnd()){
//        text = stream.readLine();
//        QString cmd = text.left(text.indexOf(";"));
//        QString freq = text.right(text.length()-text.indexOf(";")-1);
//        frequencyMap.insert(cmd, freq.toFloat());
//    }
//    MenuM::frequency = frequencyMap;
////    qDebug()<< frequencyMap;

//     //load menu file
//     QUiLoader loader;
//     QFile file(path+ "MenuVisu/menus/" + menuFileName);
//     if (!file.open(QIODevice::ReadOnly | QIODevice::Text)){
//             qDebug()<<"Menu File name is not valid: ";
//             return 0;
//     }

//     QWidget *myWidget = loader.load(&file, 0);
//     QMainWindow* mainWindow = qobject_cast<QMainWindow*>(myWidget);

//     file.close();
//     if(!mainWindow){
//         qDebug()<<"ui file is not a valid qmainWindow";
//     }

//     mainWindow->menuBar()->setNativeMenuBar(false);
//     mainWindow->move(30,30);

//     mainWindow->show();
//     MenuVisu menuVisu(mainWindow->menuBar());
//     mainWindow->resize(1100,qMin(menuVisu.height()+70, 800));
//     menuVisu.show();

//     QScrollArea *scrollArea = new QScrollArea(0);
//     mainWindow->setCentralWidget(scrollArea);
//     scrollArea->setWidget(&menuVisu);

//     //write result
//     QPixmap pixmap = QPixmap::grabWidget(&menuVisu);
//     pixmap.save(path+ directory+"menus/"+imgFileName);

//     //menuVisu.setMaximumSize(600,400);
//     //menuVisu.setMinimumSize(600,400);
//    // menuVisu.resize(600,400);
    
//    return a.exec();
//}
